# -*- coding: utf-8 -*-
from drf_spectacular.plumbing import get_relative_url, set_query_parameters
from drf_spectacular.views import SpectacularAPIView, SpectacularRedocView, SpectacularSwaggerView
from rest_framework.reverse import reverse


class ThxSpectacularAPIView(SpectacularAPIView):
    pass


class ThxSpectacularRedocView(SpectacularRedocView):
    def _get_schema_url(self, request):
        schema_url = self.url or get_relative_url(reverse(self.url_name, request=request, kwargs=self.kwargs))
        return set_query_parameters(
            profile=self.kwargs.get("profile"),
            url=schema_url,
            lang=request.GET.get('lang'),
            version=request.GET.get('version')
        )


class ThxSpectacularSwaggerView(SpectacularSwaggerView):
    def _get_schema_url(self, request):
        schema_url = self.url or get_relative_url(reverse(self.url_name, request=request, kwargs=self.kwargs))
        return set_query_parameters(
            profile=self.kwargs.get("profile"),
            url=schema_url,
            lang=request.GET.get('lang'),
            version=request.GET.get('version')
        )
